/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_TRITONAMDGPUACCELERATEMATMUL
#define GEN_PASS_DECL_TRITONAMDGPUOPTIMIZEEPILOGUE
#define GEN_PASS_DECL_TRITONAMDGPUREORDERINSTRUCTIONS
#define GEN_PASS_DECL_TRITONAMDGPUSTREAMPIPELINE
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// TritonAMDGPUAccelerateMatmul
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_TRITONAMDGPUACCELERATEMATMUL
struct TritonAMDGPUAccelerateMatmulOptions {
  std::string archGenerationName = std::string{};
  int32_t matrixInstructionSize = 0;
  int32_t kPack = 1;
};
#undef GEN_PASS_DECL_TRITONAMDGPUACCELERATEMATMUL
#endif // GEN_PASS_DECL_TRITONAMDGPUACCELERATEMATMUL
#ifdef GEN_PASS_DEF_TRITONAMDGPUACCELERATEMATMUL
namespace impl {

template <typename DerivedT>
class TritonAMDGPUAccelerateMatmulBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = TritonAMDGPUAccelerateMatmulBase;

  TritonAMDGPUAccelerateMatmulBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  TritonAMDGPUAccelerateMatmulBase(const TritonAMDGPUAccelerateMatmulBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  TritonAMDGPUAccelerateMatmulBase& operator=(const TritonAMDGPUAccelerateMatmulBase &) = delete;
  TritonAMDGPUAccelerateMatmulBase(TritonAMDGPUAccelerateMatmulBase &&) = delete;
  TritonAMDGPUAccelerateMatmulBase& operator=(TritonAMDGPUAccelerateMatmulBase &&) = delete;
  ~TritonAMDGPUAccelerateMatmulBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tritonamdgpu-accelerate-matmul");
  }
  ::llvm::StringRef getArgument() const override { return "tritonamdgpu-accelerate-matmul"; }

  ::llvm::StringRef getDescription() const override { return "accelerate matmul"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TritonAMDGPUAccelerateMatmul");
  }
  ::llvm::StringRef getName() const override { return "TritonAMDGPUAccelerateMatmul"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TritonAMDGPUAccelerateMatmulBase<DerivedT>)

  TritonAMDGPUAccelerateMatmulBase(const TritonAMDGPUAccelerateMatmulOptions &options) : TritonAMDGPUAccelerateMatmulBase() {
    archGenerationName = options.archGenerationName;
    matrixInstructionSize = options.matrixInstructionSize;
    kPack = options.kPack;
  }
protected:
  ::mlir::Pass::Option<std::string> archGenerationName{*this, "arch-generation-name", ::llvm::cl::desc("GFX generation name of target device."), ::llvm::cl::init(std::string{})};
  ::mlir::Pass::Option<int32_t> matrixInstructionSize{*this, "matrix-instruction-size", ::llvm::cl::desc("enforce matrix instruction MN size"), ::llvm::cl::init(0)};
  ::mlir::Pass::Option<int32_t> kPack{*this, "kPack", ::llvm::cl::desc("KWidth / kBase"), ::llvm::cl::init(1)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_TRITONAMDGPUACCELERATEMATMUL
#endif // GEN_PASS_DEF_TRITONAMDGPUACCELERATEMATMUL

//===----------------------------------------------------------------------===//
// TritonAMDGPUOptimizeEpilogue
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_TRITONAMDGPUOPTIMIZEEPILOGUE
#undef GEN_PASS_DECL_TRITONAMDGPUOPTIMIZEEPILOGUE
#endif // GEN_PASS_DECL_TRITONAMDGPUOPTIMIZEEPILOGUE
#ifdef GEN_PASS_DEF_TRITONAMDGPUOPTIMIZEEPILOGUE
namespace impl {

template <typename DerivedT>
class TritonAMDGPUOptimizeEpilogueBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = TritonAMDGPUOptimizeEpilogueBase;

  TritonAMDGPUOptimizeEpilogueBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  TritonAMDGPUOptimizeEpilogueBase(const TritonAMDGPUOptimizeEpilogueBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  TritonAMDGPUOptimizeEpilogueBase& operator=(const TritonAMDGPUOptimizeEpilogueBase &) = delete;
  TritonAMDGPUOptimizeEpilogueBase(TritonAMDGPUOptimizeEpilogueBase &&) = delete;
  TritonAMDGPUOptimizeEpilogueBase& operator=(TritonAMDGPUOptimizeEpilogueBase &&) = delete;
  ~TritonAMDGPUOptimizeEpilogueBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tritonamdgpu-optimize-epilogue");
  }
  ::llvm::StringRef getArgument() const override { return "tritonamdgpu-optimize-epilogue"; }

  ::llvm::StringRef getDescription() const override { return "Optimize epilogue: (1) Store accumulators directly without going thorough SMEM in epilogue."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TritonAMDGPUOptimizeEpilogue");
  }
  ::llvm::StringRef getName() const override { return "TritonAMDGPUOptimizeEpilogue"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TritonAMDGPUOptimizeEpilogueBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_TRITONAMDGPUOPTIMIZEEPILOGUE
#endif // GEN_PASS_DEF_TRITONAMDGPUOPTIMIZEEPILOGUE

//===----------------------------------------------------------------------===//
// TritonAMDGPUReorderInstructions
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_TRITONAMDGPUREORDERINSTRUCTIONS
#undef GEN_PASS_DECL_TRITONAMDGPUREORDERINSTRUCTIONS
#endif // GEN_PASS_DECL_TRITONAMDGPUREORDERINSTRUCTIONS
#ifdef GEN_PASS_DEF_TRITONAMDGPUREORDERINSTRUCTIONS
namespace impl {

template <typename DerivedT>
class TritonAMDGPUReorderInstructionsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = TritonAMDGPUReorderInstructionsBase;

  TritonAMDGPUReorderInstructionsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  TritonAMDGPUReorderInstructionsBase(const TritonAMDGPUReorderInstructionsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  TritonAMDGPUReorderInstructionsBase& operator=(const TritonAMDGPUReorderInstructionsBase &) = delete;
  TritonAMDGPUReorderInstructionsBase(TritonAMDGPUReorderInstructionsBase &&) = delete;
  TritonAMDGPUReorderInstructionsBase& operator=(TritonAMDGPUReorderInstructionsBase &&) = delete;
  ~TritonAMDGPUReorderInstructionsBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tritonamdgpu-reorder-instructions");
  }
  ::llvm::StringRef getArgument() const override { return "tritonamdgpu-reorder-instructions"; }

  ::llvm::StringRef getDescription() const override { return "Reorder instructions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TritonAMDGPUReorderInstructions");
  }
  ::llvm::StringRef getName() const override { return "TritonAMDGPUReorderInstructions"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TritonAMDGPUReorderInstructionsBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_TRITONAMDGPUREORDERINSTRUCTIONS
#endif // GEN_PASS_DEF_TRITONAMDGPUREORDERINSTRUCTIONS

//===----------------------------------------------------------------------===//
// TritonAMDGPUStreamPipeline
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_TRITONAMDGPUSTREAMPIPELINE
#undef GEN_PASS_DECL_TRITONAMDGPUSTREAMPIPELINE
#endif // GEN_PASS_DECL_TRITONAMDGPUSTREAMPIPELINE
#ifdef GEN_PASS_DEF_TRITONAMDGPUSTREAMPIPELINE
namespace impl {

template <typename DerivedT>
class TritonAMDGPUStreamPipelineBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = TritonAMDGPUStreamPipelineBase;

  TritonAMDGPUStreamPipelineBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  TritonAMDGPUStreamPipelineBase(const TritonAMDGPUStreamPipelineBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  TritonAMDGPUStreamPipelineBase& operator=(const TritonAMDGPUStreamPipelineBase &) = delete;
  TritonAMDGPUStreamPipelineBase(TritonAMDGPUStreamPipelineBase &&) = delete;
  TritonAMDGPUStreamPipelineBase& operator=(TritonAMDGPUStreamPipelineBase &&) = delete;
  ~TritonAMDGPUStreamPipelineBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tritonamdgpu-stream-pipeline");
  }
  ::llvm::StringRef getArgument() const override { return "tritonamdgpu-stream-pipeline"; }

  ::llvm::StringRef getDescription() const override { return "pipeline"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TritonAMDGPUStreamPipeline");
  }
  ::llvm::StringRef getName() const override { return "TritonAMDGPUStreamPipeline"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TritonAMDGPUStreamPipelineBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_TRITONAMDGPUSTREAMPIPELINE
#endif // GEN_PASS_DEF_TRITONAMDGPUSTREAMPIPELINE
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// TritonAMDGPUAccelerateMatmul Registration
//===----------------------------------------------------------------------===//

inline void registerTritonAMDGPUAccelerateMatmul() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::createTritonAMDGPUAccelerateMatmulPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerTritonAMDGPUAccelerateMatmulPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::createTritonAMDGPUAccelerateMatmulPass();
  });
}

//===----------------------------------------------------------------------===//
// TritonAMDGPUOptimizeEpilogue Registration
//===----------------------------------------------------------------------===//

inline void registerTritonAMDGPUOptimizeEpilogue() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::createTritonAMDGPUOptimizeEpiloguePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerTritonAMDGPUOptimizeEpiloguePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::createTritonAMDGPUOptimizeEpiloguePass();
  });
}

//===----------------------------------------------------------------------===//
// TritonAMDGPUReorderInstructions Registration
//===----------------------------------------------------------------------===//

inline void registerTritonAMDGPUReorderInstructions() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::createTritonAMDGPUReorderInstructionsPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerTritonAMDGPUReorderInstructionsPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::createTritonAMDGPUReorderInstructionsPass();
  });
}

//===----------------------------------------------------------------------===//
// TritonAMDGPUStreamPipeline Registration
//===----------------------------------------------------------------------===//

inline void registerTritonAMDGPUStreamPipeline() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::createTritonAMDGPUStreamPipelinePass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerTritonAMDGPUStreamPipelinePass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::createTritonAMDGPUStreamPipelinePass();
  });
}

//===----------------------------------------------------------------------===//
// TritonAMDGPU Registration
//===----------------------------------------------------------------------===//

inline void registerTritonAMDGPUPasses() {
  registerTritonAMDGPUAccelerateMatmul();
  registerTritonAMDGPUOptimizeEpilogue();
  registerTritonAMDGPUReorderInstructions();
  registerTritonAMDGPUStreamPipeline();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class TritonAMDGPUAccelerateMatmulBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = TritonAMDGPUAccelerateMatmulBase;

  TritonAMDGPUAccelerateMatmulBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  TritonAMDGPUAccelerateMatmulBase(const TritonAMDGPUAccelerateMatmulBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  TritonAMDGPUAccelerateMatmulBase& operator=(const TritonAMDGPUAccelerateMatmulBase &) = delete;
  TritonAMDGPUAccelerateMatmulBase(TritonAMDGPUAccelerateMatmulBase &&) = delete;
  TritonAMDGPUAccelerateMatmulBase& operator=(TritonAMDGPUAccelerateMatmulBase &&) = delete;
  ~TritonAMDGPUAccelerateMatmulBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tritonamdgpu-accelerate-matmul");
  }
  ::llvm::StringRef getArgument() const override { return "tritonamdgpu-accelerate-matmul"; }

  ::llvm::StringRef getDescription() const override { return "accelerate matmul"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TritonAMDGPUAccelerateMatmul");
  }
  ::llvm::StringRef getName() const override { return "TritonAMDGPUAccelerateMatmul"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TritonAMDGPUAccelerateMatmulBase<DerivedT>)

protected:
  ::mlir::Pass::Option<std::string> archGenerationName{*this, "arch-generation-name", ::llvm::cl::desc("GFX generation name of target device."), ::llvm::cl::init(std::string{})};
  ::mlir::Pass::Option<int32_t> matrixInstructionSize{*this, "matrix-instruction-size", ::llvm::cl::desc("enforce matrix instruction MN size"), ::llvm::cl::init(0)};
  ::mlir::Pass::Option<int32_t> kPack{*this, "kPack", ::llvm::cl::desc("KWidth / kBase"), ::llvm::cl::init(1)};
};

template <typename DerivedT>
class TritonAMDGPUOptimizeEpilogueBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = TritonAMDGPUOptimizeEpilogueBase;

  TritonAMDGPUOptimizeEpilogueBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  TritonAMDGPUOptimizeEpilogueBase(const TritonAMDGPUOptimizeEpilogueBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  TritonAMDGPUOptimizeEpilogueBase& operator=(const TritonAMDGPUOptimizeEpilogueBase &) = delete;
  TritonAMDGPUOptimizeEpilogueBase(TritonAMDGPUOptimizeEpilogueBase &&) = delete;
  TritonAMDGPUOptimizeEpilogueBase& operator=(TritonAMDGPUOptimizeEpilogueBase &&) = delete;
  ~TritonAMDGPUOptimizeEpilogueBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tritonamdgpu-optimize-epilogue");
  }
  ::llvm::StringRef getArgument() const override { return "tritonamdgpu-optimize-epilogue"; }

  ::llvm::StringRef getDescription() const override { return "Optimize epilogue: (1) Store accumulators directly without going thorough SMEM in epilogue."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TritonAMDGPUOptimizeEpilogue");
  }
  ::llvm::StringRef getName() const override { return "TritonAMDGPUOptimizeEpilogue"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TritonAMDGPUOptimizeEpilogueBase<DerivedT>)

protected:
};

template <typename DerivedT>
class TritonAMDGPUReorderInstructionsBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = TritonAMDGPUReorderInstructionsBase;

  TritonAMDGPUReorderInstructionsBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  TritonAMDGPUReorderInstructionsBase(const TritonAMDGPUReorderInstructionsBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  TritonAMDGPUReorderInstructionsBase& operator=(const TritonAMDGPUReorderInstructionsBase &) = delete;
  TritonAMDGPUReorderInstructionsBase(TritonAMDGPUReorderInstructionsBase &&) = delete;
  TritonAMDGPUReorderInstructionsBase& operator=(TritonAMDGPUReorderInstructionsBase &&) = delete;
  ~TritonAMDGPUReorderInstructionsBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tritonamdgpu-reorder-instructions");
  }
  ::llvm::StringRef getArgument() const override { return "tritonamdgpu-reorder-instructions"; }

  ::llvm::StringRef getDescription() const override { return "Reorder instructions"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TritonAMDGPUReorderInstructions");
  }
  ::llvm::StringRef getName() const override { return "TritonAMDGPUReorderInstructions"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TritonAMDGPUReorderInstructionsBase<DerivedT>)

protected:
};

template <typename DerivedT>
class TritonAMDGPUStreamPipelineBase : public ::mlir::OperationPass<mlir::ModuleOp> {
public:
  using Base = TritonAMDGPUStreamPipelineBase;

  TritonAMDGPUStreamPipelineBase() : ::mlir::OperationPass<mlir::ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  TritonAMDGPUStreamPipelineBase(const TritonAMDGPUStreamPipelineBase &other) : ::mlir::OperationPass<mlir::ModuleOp>(other) {}
  TritonAMDGPUStreamPipelineBase& operator=(const TritonAMDGPUStreamPipelineBase &) = delete;
  TritonAMDGPUStreamPipelineBase(TritonAMDGPUStreamPipelineBase &&) = delete;
  TritonAMDGPUStreamPipelineBase& operator=(TritonAMDGPUStreamPipelineBase &&) = delete;
  ~TritonAMDGPUStreamPipelineBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tritonamdgpu-stream-pipeline");
  }
  ::llvm::StringRef getArgument() const override { return "tritonamdgpu-stream-pipeline"; }

  ::llvm::StringRef getDescription() const override { return "pipeline"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TritonAMDGPUStreamPipeline");
  }
  ::llvm::StringRef getName() const override { return "TritonAMDGPUStreamPipeline"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TritonAMDGPUStreamPipelineBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
